/* Doubly linked-list implementation for containing items of type ListItem.
 *
 * Notice the file-modular interface: the List type is opaque, but permits
 * total access via the public interface. This means that virtually anything
 * about the list data-structure can be changed without affecting client code.
 *
 * Tim Bailey 2004. */

#ifndef DOUBLY_LINKED_LIST_H_
#define DOUBLY_LINKED_LIST_H_

typedef short ListItem;
typedef struct List List;

/* creation and insertion */
List *list_insert_front(List *node, ListItem item);
List *list_insert_back(List *node, ListItem item);
List *list_insert_after(List *node, ListItem item);
List *list_insert_before(List *node, ListItem item);

/* deletion */
void list_delete_node(List *node);
List *list_delete_after(List *node);
List *list_delete_before(List *node);
void list_delete_all_lists(void);

/* access */
List *list_get_head(List *node);
List *list_get_tail(List *node);
List *list_get_next(List *node);
List *list_get_prev(List *node);
ListItem *list_get_item(List *node);

#endif
